varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2; // TODO: This is not used

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2; // lookup texture

uniform lowp float intensity;
uniform lowp float lutImageSize; //image 512 or 64
uniform lowp float isEnableLut ;// 0.0 1.0
uniform lowp float lutSize;//8 or 4

void main()
{
    highp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    
    if( isEnableLut < 0.5) //说明是原图，不进行查找lut表
        gl_FragColor = textureColor;
    else
    {
        if((textureColor.r < 0.000001) && (textureColor.g < 0.000001) && (textureColor.b < 0.000001))
            gl_FragColor = textureColor;
        else {
            highp float blueColor = textureColor.b * (lutSize*lutSize -1.0);
            
            highp vec2 quad1;
            quad1.y  = max(min(lutSize,floor(floor(blueColor) / lutSize)),0.0);
            quad1.x  = max(min(lutSize,floor(blueColor) - (quad1.y * lutSize)),0.0);
            
            highp vec2 quad2;
            quad2.y = max(min(floor(ceil(blueColor) / lutSize),lutSize),0.0);
            quad2.x = max(min(ceil(blueColor) - (quad2.y * lutSize),lutSize),0.0);
            
            
            highp vec2 texPos1;
            texPos1.x = (quad1.x / lutSize) + 0.5/lutImageSize + ((1.0 /lutSize - 1.0/lutImageSize) * textureColor.r);
            texPos1.y = (quad1.y / lutSize) + 0.5/lutImageSize + ((1.0 /lutSize - 1.0/lutImageSize) * textureColor.g);
            
            highp vec2 texPos2;
            texPos2.x = (quad2.x /lutSize) + 0.5/lutImageSize + ((1.0 /lutSize- 1.0/lutImageSize) * textureColor.r);
            texPos2.y = (quad2.y /lutSize) + 0.5/lutImageSize + ((1.0 /lutSize - 1.0/lutImageSize) * textureColor.g);
            
            highp vec4 newColor1 = texture2D(inputImageTexture2, texPos1);
            highp vec4 newColor2 = texture2D(inputImageTexture2, texPos2);
            
            highp vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
            gl_FragColor = mix(textureColor, vec4(newColor.rgb, textureColor.w), intensity);
        }
    }
}
